#include "mpi.h"

int addem(invec, inoutvec, len)
int *invec, *inoutvec, len;
{
  int i;
  for ( i=0; i<len; i++ ) 
    inoutvec[i] += invec[i];
  return (1);
}

#define BAD_ANSWER 100000

int assoc(invec, inoutvec, len)
int *invec, *inoutvec, len;
{
  int i;
  for ( i=0; i<len; i++ )  {
    if (inoutvec[i] > invec[i] )
      inoutvec[i] = BAD_ANSWER;
    else 
      inoutvec[i] = invec[i];
  }
  return (1);
}

worker( argc, argv )
int argc;
char **argv;
{
    int              rank, size, i;
    MPI_Comm_request handle;
    MPI_Status       status;
    int              data;
    int              errors=0;
    int              result = -100;
    int              correct_result;

    MPI_Init( &argc, argv );
    MPI_Comm_rank( MPI_COMM_WORLD, &rank );
    MPI_Comm_size( MPI_COMM_WORLD, &size );

    data = rank;

    correct_result = 0;
    for (i=0;i<=rank;i++)
      correct_result += i;

    MPI_Scan ( &data, &result, 1, MPI_INT, MPI_SUM, MPI_COMM_WORLD );
    if (result != correct_result) errors++;

    MPI_Scan ( &data, &data, 1, MPI_INT, MPI_SUM, MPI_COMM_WORLD );
    if (data != correct_result) errors++;

    data = rank;
    result = -100;
    MPI_User_scan ( &data, &result, 1, MPI_INT, addem, MPI_COMM_WORLD );
    if (result != correct_result) errors++;

    MPI_User_scan ( &data, &data, 1, MPI_INT, addem, MPI_COMM_WORLD );
    if (data != correct_result) errors++;

    result = -100;
    data = rank;
    MPI_User_scana ( &data, &result, 1, MPI_INT, assoc, MPI_COMM_WORLD );
    if (result == BAD_ANSWER) errors++;

    MPI_Finalize();
    if (errors)
      printf( "[%d] done with ERRORS(%d)!\n", rank, errors );
    else
      printf( "[%d] SUCCESSFUL!\n", rank );
}
